#include <PalmOS.h>
#include <stdio.h>
#include "rbst.h"

#define DT  (6)
#define DX  (6)
#define HDX (3)     /* DX/2 */
#define QDX (2)     /* DX/4 */
#define NMAX  (32)  /* ... WID/DX + 4 + alpha */
#define EXPD  (64)
#define HEXPD (32)  /* EXPD/2 */

Boolean released=False;
Boolean quit=False;
Boolean reset=False;
Boolean pause=False;
Boolean pendown=False;
int under=0;

int dtype=LINES;

RectangleType rect;
RectangleType pnt;

int step=0;
char msg[256];

int px[NMAX];
int py[NMAX];
//double dpx[NMAX];
long u[NMAX];
long u0[NMAX];
long un[NMAX];
int max;
int penx, peny;
int addx;

/* constant k = ka/kb */
int ka=1;
int kb=1;
//double k=1.0;
//double kk;
//double kk2;
//double kk4;

RectangleType rect;

int frmno=0;
FormPtr frm[2];




/* subroutines */

int XtoI(int x)
{
    return (x-addx)/DX+1;
}

int IsUnder(int pnx, int pny)
{
    int i;
    long utmp;

    i=XtoI(penx);
    utmp=u[i]+((u[i+1]-u[i])*(pnx-px[i]+HDX))/DX;
    if(utmp-pny*EXPD>0){
        return 1;
    }else{
        return -1;
    }
}

void DrawString()
{
    int i;
/*    int tmpx, tmpy;*/

    for(i=2; i<max-2; i++){
        py[i]=(u[i]+HEXPD)/EXPD;
    }

    if(released){
        frmno=1-frmno;
        FrmSetActiveForm(frm[frmno]);
/*    FrmDrawForm(frm[frmno]);*/
    }
    WinEraseRectangle(&rect, 0);
/*    if(dtype==PTS){
        tmpx=pnt.extent.x/2;  tmpy=pnt.extent.y/2;
        for(i=1; i<max-1; i++){
            pnt.topLeft.x=px[i]-tmpx;
            pnt.topLeft.y=py[i]-tmpy;
            WinDrawRectangle(&pnt, 0);
        }
    }else{*/
        for(i=2; i<max-1; i++){
            WinDrawLine(px[i], py[i], px[i-1], py[i-1]);
            WinDrawLine(px[i], py[i]-1, px[i-1], py[i-1]-1);
        }
/*    }*/
/*    sprintf(msg, "step: %4d  ", step);
    WinDrawChars(msg, StrLen(msg), 16, 142);*/
/*    FrmEraseForm(frm[1-frmno]);*/
    FrmDrawForm(frm[frmno]);
}


/* Event Handling */

void MenuHandling(int id)
{
    FormPtr frma;

    switch(id){
      case ID_MENU_ABOUT:
        frma=FrmInitForm(ID_ABOUT);
        FrmDoDialog(frma);
        FrmDeleteForm(frma);
        break;
      case ID_MENU_RESET:
        reset=True;
        break;
      case ID_MENU_QUIT:
        quit=True;
        break;
      case ID_MENU_LINES:
        dtype=LINES;
        DrawString();
        break;
      case ID_MENU_PTS:
        dtype=PTS;
        DrawString();
        break;
      default:
    }
}



/* initialize value term */

void SetValues(int px2, int py2)
{
    int i;
    long dpx2, ddpx2, dpy2;
//    char msg[256];

    dpx2=px2-px[1];  ddpx2=px[max-2]-px2;
    dpy2=py2-Y0;
//    sprintf(msg, "%4d %4d %4d %4d  ", px2, py2,
//              (int)(1000*dpx2), (int)(1000*ddpx2));
//    WinDrawChars(msg, StrLen(msg), 4, 118);

    for(i=2; i<max-2; i++){
        if(px[i]<px2){
            u[i]=Y0*EXPD+(dpy2*(px[i]-px[1])*EXPD)/dpx2;
            py[i]=u[i]/EXPD;
        }else{
            u[i]=Y0*EXPD+(dpy2*(px[max-2]-px[i])*EXPD)/ddpx2;
            py[i]=u[i]/EXPD;
        }
    }
}

void DragLoop(int ox, int oy)
{
    Boolean PenDown;
    Int16 px1=0, py1=0;
    int px2, py2;
    int adj=HDX;  /* adjustment */

    do{
        do{
            px2=px1;  py2=py1;
            EvtGetPen(&px1, &py1, &PenDown);
        }while(px1==px2 && py1==py2 && PenDown);
//        }while(PenDown && 4<EvtPenQueueSize());
//        sprintf(msg, "%4d %4d %4d  ", px1, py1, (oy-Y0)*(py1-Y0));
//        WinDrawChars(msg, StrLen(msg), 4, 146);
        px2=px1;
        if(0<=(oy-Y0)*(py1-Y0)){
            py2=Y0;
        }else if(0<py1-Y0){
            py2=py1+adj;
        }else{
            py2=py1-adj;
        }
/*        sprintf(msg, "%4d %4d   ", px2, py2);
        WinDrawChars(msg, StrLen(msg), 4, 132);*/
        SetValues(px2, py2);
        DrawString();
    }while(PenDown);
    if((oy-Y0)*(py1-Y0)<0){
        released=True;  pause=False;
    }
}

Boolean InitEventHandler(EventPtr e)
{
    Boolean ret=False;

    switch(e->eType){
      case penDownEvent:
        DragLoop(e->screenX, e->screenY);
        ret=True;
        break;
      case menuEvent:
        MenuHandling(e->data.menu.itemID);
        break;
      case appStopEvent:
        quit=True;
        ret=True;
        break;
      default:
    }
    return ret;
}

void InitEventLoop()
{
    EventType event;
    UInt16 err;

    do{
        EvtGetEvent(&event, -1);
        if(!SysHandleEvent(&event)){
            if(!MenuHandleEvent(NULL, &event, &err)){
                if(!InitEventHandler(&event))
                        FrmHandleEvent(FrmGetActiveForm(), &event);
            }
        }
    }while((!released) && (!quit) && (!reset));
}

void SetConditions()
{
    int i;

    step=0;
    for(i=0; i<max; i++){
        un[i]=u0[i]=u[i];
    }
}


/* main loops */

void Solver()
{
    int i;
    long tmp;
    long kka=ka*ka*DT*DT;
    long kkb=2*kb*kb*DX*DX;

    step++;
    for(i=2; i<max-2; i++){
/*        un[i]=2.0*u[i]-u0[i]+kk*(u[i+1]-2.0*u[i]+u[i-1]);*/
/*        un[i]=2.0*u[i]-u0[i]+kk2*(u[i+1]-3.0*u[i]+u[i-1])
                +kk4*(u[i+2]+u[i-2]);*/
        tmp=(u[i+1]-3*u[i]+u[i-1])+(u[i+2]+u[i-2])/2;
/*        un[i]=2*u[i]-u0[i]+(tmp*kka)/kkb;*/
        un[i]=u[i]+(u[i]-u0[i])+(tmp*kka)/kkb+(u[i+1]-u[i]-u[i]+u[i-1])/15;
    }
    for(i=2; i<max-2; i++){
        u0[i]=u[i];  u[i]=un[i];
    }
}

void PicA(int i)
{
    long utmp=peny*EXPD;
    int adj=QDX*EXPD;  /* adjustment */

    if(u[i]-utmp>0){
        u[i]=utmp-adj;
    }else{
        u[i]=utmp+adj;
    }
}

void PicB(int i)
{
    long utmp=2*peny*EXPD;
    long ua, uadj;
    int adj=HDX*EXPD;  /* adjustment */

    ua =u[i] +u[i+1];
    uadj=(ua-utmp)/2;
    if(uadj>0){
        uadj+=adj;
    }else{
        uadj-=adj;
    }
    u[i]-=uadj;  u[i+1]-=uadj;
}

void PicString()
{
    int i;

    if(under*IsUnder(penx, peny)<0){
        i=XtoI(penx);  PicB(i);
/*        if(penx-px[i]<=QDX){
            PicA(i);
        }else if(px[i+1]-penx<=QDX){
            PicA(i+1);
        }else{
            PicB(i);
        }*/
    }
}


Boolean MainEventHandler(EventPtr e)
{
    Boolean ret=False;

    switch(e->eType){
      case menuOpenEvent:
        pause=True;
        ret=True;
        return ret;
        break;
      case menuCloseEvent:
        break;
      case menuEvent:
        MenuHandling(e->data.menu.itemID);
        ret=True;
        return ret;
        break;
      case penDownEvent:
        if(e->screenY>HGT) break;
        pendown=True;  pause=False;
        penx=e->screenX;  peny=e->screenY;
        under=IsUnder(penx, peny);
        ret=True;
        break;
      case penUpEvent:
        pendown=False;
        ret=True;
        break;
      case appStopEvent:
        quit=True;
        ret=True;
        return ret;
        break;
      case penMoveEvent:
        penx=e->screenX;  peny=e->screenY;
        ret=True;
        /*break;*/
      case nilEvent:
        if(!pause){
            Solver();
            if(pendown){
                PicString();
            }
            DrawString();
        }
        break;
      default:
    }

    return ret;
}

void MainEventLoop()
{
    EventType event;
    UInt16 err;

    do{
        EvtGetEvent(&event, 5);
        if(!SysHandleEvent(&event)){
            if(MenuHandleEvent(NULL, &event, &err)){
                pause=True;
            }else if(!MainEventHandler(&event)){
                FrmHandleEvent(FrmGetActiveForm(), &event);
            }
        }
    }while((!quit) && (!reset));
}




/* initialize app */

void InitializeApp(void)
{
    frm[0]=FrmInitForm(ID_MAINFORM1);
    frm[1]=FrmInitForm(ID_MAINFORM2);
    frmno=0;
    FrmSetActiveForm(frm[frmno]);
    FrmDrawForm(frm[frmno]);

    rect.topLeft.x=0;
    rect.topLeft.y=0;
    rect.extent.x=WID;
    rect.extent.y=HGT;

    pnt.topLeft.x=0;
    pnt.topLeft.y=0;
    pnt.extent.x=3;
    pnt.extent.y=3;
}

void InitializeValues(void)
{
    int i;

    released=False;
    reset=False;
    pendown=False;
    step=0;

    px[0]=-DX;
    px[1]=0;
    i=1;
    do{
        i++;
        px[i]=px[i-1]+DX;
    }while(px[i]<WID);
    max=i+1;
    addx=(WID-px[max-2])/2;
    for(i=0; i<max; i++){
        px[i]+=addx;
        py[i]=Y0;
        u[i]=Y0*EXPD;
    }
}


/* main */

void MainLoop()
{
   do{
        InitializeValues();
        DrawString();
        InitEventLoop();
        SetConditions();
        MainEventLoop();
   }while(!quit);
}


UInt32 PilotMain(UInt16 cmd, void *cmdPBP, UInt16 launchFlags)
{
    switch(cmd){
      case sysAppLaunchCmdNormalLaunch:
        InitializeApp();
        MainLoop();
        break;
      default:
    }
    return(0);
}
